#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Windows.Forms;
using HeuristicLab.MainForm;
using HeuristicLab.Clients.Common;
using HeuristicLab.Clients.OKB.OKBAdmin;
using System.ComponentModel;
using System.Collections.Generic;
using System.Data;
using System;

namespace HeuristicLab.Clients.OKB {
  [View("OKB Administration")]
  public partial class AdministrationView : HeuristicLab.MainForm.WindowsForms.View {
    List<AlgorithmClass> data;

    public AdministrationView() {
      InitializeComponent();
    }

    private void refreshButton_Click(object sender, System.EventArgs e) {
      IAdminService adminService = ClientFactory.CreateClient<AdminServiceClient, IAdminService>();
      data = adminService.GetAlgorithmClasses();
      algorithmClassBindingSource.DataSource = data;
    }

    private void saveButton_Click(object sender, System.EventArgs e) {
      IAdminService adminService = ClientFactory.CreateClient<AdminServiceClient, IAdminService>();
    }

    private void populateButton_Click(object sender, System.EventArgs e) {
      IAdminService adminService = ClientFactory.CreateClient<AdminServiceClient, IAdminService>();
      for (int i = 0; i < 100; i++)
        adminService.AddAlgorithmClass(new AlgorithmClass() { Name = Guid.NewGuid().ToString() });
    }

    private void dataGridView1_CellEndEdit(object sender, DataGridViewCellEventArgs e) {
      IAdminService adminService = ClientFactory.CreateClient<AdminServiceClient, IAdminService>();
      adminService.UpdateAlgorithmClass(data[e.RowIndex]);
    }

    private void dataGridView1_UserAddedRow(object sender, DataGridViewRowEventArgs e) {
      IAdminService adminService = ClientFactory.CreateClient<AdminServiceClient, IAdminService>();
      adminService.AddAlgorithmClass(new AlgorithmClass() {
        Name = (string)e.Row.Cells["Name"].Value,
        Description = (string)e.Row.Cells["Description"].Value
      });
    }

    private void dataGridView1_UserDeletedRow(object sender, DataGridViewRowEventArgs e) {
      IAdminService adminService = ClientFactory.CreateClient<AdminServiceClient, IAdminService>();
      adminService.DeleteAlgorithmClass((long)e.Row.Cells["Id"].Value);
    }
  }
}
